///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL GetValues(void)
{
    unsigned long SizeOfBuffer = 256;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, ExpireDateKey, "SBED", ExpireDate))
        return FALSE;

    ClearMem(HelpPath, 8);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "HelpPath", HelpPath, SizeOfBuffer))
        return FALSE;

    ClearMem(RegKey1, 8);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RegKey1", RegKey1, SizeOfBuffer))
        return FALSE;

    ClearMem(RegKey2, 8);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RegKey2", RegKey2, SizeOfBuffer))
        return FALSE;

    ClearMem(RegKey3, 8);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RegKey3", RegKey3, SizeOfBuffer))
        return FALSE;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "CheckRegistration", (DWORD &)CheckRegistration))
        return FALSE;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "SavePassword", (DWORD &)SavePassword))
        return FALSE;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterTrusted", (DWORD &)MasterTrusted))
        return FALSE;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupTrusted", (DWORD &)BackupTrusted))
        return FALSE;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreTrusted", (DWORD &)RestoreTrusted))
        return FALSE;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "AllOnHold", (DWORD &)AllOnHold))
        return FALSE;

    ClearMem(UserKey, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "UserKey", UserKey, SizeOfBuffer))
        return FALSE;

    ClearMem(BackupServer, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupServer", BackupServer, SizeOfBuffer))
        return FALSE;

    ClearMem(RestoreServer, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreServer", RestoreServer, SizeOfBuffer))
        return FALSE;

    ClearMem(BackupDataBase, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupDataBase", BackupDataBase, SizeOfBuffer))
        return FALSE;

    ClearMem(RestoreDataBase, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreDataBase", RestoreDataBase, SizeOfBuffer))
        return FALSE;

    ClearMem(BackupDriver, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupDriver", BackupDriver, SizeOfBuffer))
        return FALSE;

    ClearMem(RestoreDriver, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreDriver", RestoreDriver, SizeOfBuffer))
        return FALSE;

    ClearMem(BackupDataBase, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupDataBase", BackupDataBase, SizeOfBuffer))
        return FALSE;

    ClearMem(RestoreDataBase, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreDataBase", RestoreDataBase, SizeOfBuffer))
        return FALSE;

    ClearMem(BackupUserID, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupUserID", BackupUserID, SizeOfBuffer))
        return FALSE;

//    ClearMem(BackupUserPW, 256);
//    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupUserPW", BackupUserPW, SizeOfBuffer))
//        return FALSE;

    ClearMem(RestoreUserID, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreUserID", RestoreUserID, SizeOfBuffer))
        return FALSE;

//    ClearMem(RestoreUserPW, 256);
//    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreUserPW", RestoreUserPW, SizeOfBuffer))
//        return FALSE;

    ClearMem(BackupFile, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupFile", BackupFile, SizeOfBuffer))
        return FALSE;

    ClearMem(RestoreFile, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreFile", RestoreFile, SizeOfBuffer))
        return FALSE;

    ClearMem(JobLogDB, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "JobLogDB", JobLogDB, SizeOfBuffer))
        return FALSE;

    ClearMem(ScheduleDB, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "ScheduleDB", ScheduleDB, SizeOfBuffer))
        return FALSE;

    ClearMem(CodedKeysDB, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "CodedKeysDB", CodedKeysDB, SizeOfBuffer))
        return FALSE;

    //-------------------------------------------------------------------------------------------------------

    ClearMem(MasterDriver, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterDriver", MasterDriver, SizeOfBuffer))
        return FALSE;

    ClearMem(MasterServer, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterServer", MasterServer, SizeOfBuffer))
        return FALSE;

    ClearMem(MasterDatabase, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterDatabase", MasterDatabase, SizeOfBuffer))
        return FALSE;

    ClearMem(MasterUID, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterUID", MasterUID, SizeOfBuffer))
        return FALSE;

    ClearMem(MasterPWS, 256);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterPWS", MasterPWS, SizeOfBuffer))
        return FALSE;

    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////

BOOL SetValues(void)
{
    if(!Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, ExpireDateKey, "SBED", ExpireDate))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RegKey1", RegKey1))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RegKey2", RegKey2))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RegKey3", RegKey3))
        return FALSE;

    if(!Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "CheckRegistration", (DWORD)CheckRegistration))
        return FALSE;

    if(!Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "SavePassword", (DWORD)SavePassword))
        return FALSE;

    if(!Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterTrusted", (DWORD)MasterTrusted))
        return FALSE;

    if(!Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupTrusted", (DWORD)BackupTrusted))
        return FALSE;

    if(!Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreTrusted", (DWORD)RestoreTrusted))
        return FALSE;

    if(!Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "AllOnHold", (DWORD)AllOnHold))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupServer", BackupServer))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreServer", RestoreServer))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupDataBase", BackupDataBase))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreDataBase", RestoreDataBase))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupDriver", BackupDriver))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreDriver", RestoreDriver))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupDataBase", BackupDataBase))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreDataBase", RestoreDataBase))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupUserID", BackupUserID))
        return FALSE;

//    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupUserPW", BackupUserPW))
//        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreUserID", RestoreUserID))
        return FALSE;

//    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreUserPW", RestoreUserPW))
//        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BackupFile", BackupFile))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "RestoreFile", RestoreFile))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "JobLogDB", JobLogDB))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "ScheduleDB", ScheduleDB))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "CodedKeysDB", CodedKeysDB))
        return FALSE;

    //-------------------------------------------------------------------------------------------------------

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterDriver", MasterDriver))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterServer", MasterServer))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterDatabase", MasterDatabase))
        return FALSE;

    if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterUID", MasterUID))
        return FALSE;

    if(SavePassword)
    {
        if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterPWS", MasterPWS))
            return FALSE;
    }
    else{
        if(!Set_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "MasterPWS", ""))
            return FALSE;
    }

    return TRUE;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

