////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ExpireCheckCount = 0;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL Interval(void)
{
    if(!IsRegistered && !IsExpired)
    {
        if(ExpireCheckCount > 60)
        {
            if(!CheckExpiration())
                return FALSE;

            ExpireCheckCount = -1;
        }

        ExpireCheckCount++;
    }

    if(IsExpired)
        return FALSE;

    if(AllOnHold)
        return TRUE;

    if(CurrentlyRunning)
        return TRUE;

    int Schedule = CheckSchedule();

    if(Schedule > -1)
    {
        SQLProcess.IsTrusted = Sched[Schedule].IsTrusted;

        SQLProcess.ScheduleItem = Schedule;

        CopyString(Sched[Schedule].Database,  SQLProcess.DataBase, strlen(Sched[Schedule].Database));
        CopyString(Sched[Schedule].DBDriver,  SQLProcess.Driver,   strlen(Sched[Schedule].DBDriver));
        CopyString(Sched[Schedule].SQLServer, SQLProcess.Server,   strlen(Sched[Schedule].SQLServer));
        CopyString(Sched[Schedule].Username,  SQLProcess.UserID,   strlen(Sched[Schedule].Username));
        CopyString(Sched[Schedule].Password,  SQLProcess.UserPW,   strlen(Sched[Schedule].Password));

        RunningManual = FALSE;
        BackupJob(Sched[Schedule].Filename);
    }

    return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

